/* This is example for encoding and decoding voice file with 
 * sampling frequency 8000Hz and 16bit per sample. The codec based on the 
 * ACELP.  Frame size is 120 samples in PCM format.
 * Developed by:
 * VIMAS Technologies,
 * www.vimas.com
 * info@vimas.com
 */

import java.io.*;
import codec.*;

public class CodecTest 
{
	
	static short COMPRESSED_FRAME_SIZE = 15;//compressed frame size
	static short FRAME_SIZE	= 120;//input voice frame size. 120 samples, 16bit per sample
	
	public static void main(String args[])
	{
		FileInputStream inEncoder;
		FileOutputStream outEncoder;	
		FileOutputStream outDecoder;
		
		int i;
		short VadDecision;
        short LossFrame=0;
		try
		{
		    inEncoder = new FileInputStream("orig.pcm"); // original voice file
			outEncoder = new FileOutputStream("orig.prm");//compressed voice file
			outDecoder = new FileOutputStream("orig_d.pcm");// decompressed voice file	
			
			Codec VoiceCodec = new Codec();	
			byte[] inArr = new byte[2*FRAME_SIZE];// input voice frame			                                      
			byte[] outArr = new byte[COMPRESSED_FRAME_SIZE];// compressed voice frame
			byte[] sintArr = new byte[2*FRAME_SIZE]; // decompressed voice frame	
			int byteRead = inEncoder.read( inArr, 0, 2*FRAME_SIZE );//read input frame
			i=0;	
			while( byteRead == 2*FRAME_SIZE)
			{
				VadDecision=VoiceCodec.FrameEncoder(inArr, outArr,(short)100);//encode voice frame
				outEncoder.write(outArr, 0, COMPRESSED_FRAME_SIZE);//write encoded frame
				
				VoiceCodec.FrameDecoder(outArr,sintArr,LossFrame);// decode encoded frame		
				outDecoder.write(sintArr, 0, 2*FRAME_SIZE );      //write decoded frame
				
				byteRead = inEncoder.read( inArr, 0, 2*FRAME_SIZE );// read next voice frame for
				i++;                                                // encoding
			}
			inEncoder.close();
			outDecoder.close();
			outEncoder.close();			
		}
		
		catch(IOException exept)
		{
		}
	
	}
}
